/**
  Generated Main Source File
    16F1705_Pulse Rate
  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F1705
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"

// O[oϐ錾
unsigned int Flag;                      // tO
unsigned long PulseRate;                // ϐ 
unsigned long Min=50;                   // ͈():50/
unsigned long Max=80;                   // ͈():80/
unsigned long Count;                    // gs[Ntos[ÑTvOJEgϐ
unsigned long Result;                   // TvOϐ(݂̒l)
unsigned long Prev;                     // TvOϐ(O̒l)
unsigned long Threshold=512;            // g̎Ro臒l
unsigned long Period=20;                // TvO(^C}[)[msec]               
unsigned long TimeOut=65;              // o^CAEg臒l(^C}[)


// vg^CsO錾
void TMR2_Interrupt(void);          // ^C}[2 ֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                 // t\Wo͊֐Ƃ
}

/*
    Main application
 */

void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    TMR2_SetInterruptHandler(TMR2_Interrupt);       // TMR2_Interrupt:[U[֐̒`
    
    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();              // O[o

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();          // ӊ

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // ϐ    
    Count = 0;              // TvOJEgNA
    Flag = 0;               // Flag
    Prev = 500;             // TvOϐ

    // LCD
    lcd_init();             // LCD      
    
    while (1)
    {
        // Add your application code

        // LCDo
        lcd_cmd(0x80);                      // LCD1s
            printf("ADC=%4lu", Result);       // ADϊl\ 
           
        if ((Min < PulseRate) && (PulseRate < Max)) {     // v͈͓Ȃ
            lcd_cmd(0xC0);                  // LCD2s
            printf("PR= %4lu", PulseRate);       // \            
        }

        else {                              // v͈͊OȂ
            lcd_cmd(0xC0);                  // LCD2s
            printf("- wait - ");            // ҂\   
        }            

        __delay_ms(1000);                   // LCD\(1sec)                

    }                        
}

// ^C}[2 荞ݏ֐
void TMR2_Interrupt(void) {

    Result = ADC_GetConversion(channel_AN3);    // ADCϊ(10rbg\)ǂݏo         

    // XԖڂ̖gs[No
    if (Flag == 0) {            // Flag:0Ȃ

        if (Result > Threshold) {      // g̎Ro

            if (Prev < Result)          // Prev < Result Ȃ
                Prev = Result;          // PrevXV        

            else {                      // gs[NoȂ
                Flag = 1;               // Flag؂ւ
                Prev = 500;             // Prev
            }
        }           
    }
    
    // X+1Ԗڂ̖gs[No           
    else {

        Count++;                // TvOJEgJn

        if (Count > TimeOut) {          // gs[No^CAEgȂ
            Flag = 0;                   // FlagZbg
            Count = 0;                  // CountZbg
            Prev = 500;                 // Prev
        }                        

        else {        

            if (Result > Threshold) {      // g̎Ro             

                if (Prev < Result)          // Prev < Result Ȃ
                    Prev = Result;          // PrevXV        

                else {                      // gs[NoȂ
                    Flag = 0;               // Flag                        
                    PulseRate = 60000 / (Period * Count);       // vZ
                    Count = 0;              // CountZbg
                    Prev = 500;             // Prev                    
                }            
            }            
        }
    }
}

/**
 End of File
*/